      PROGRAM ORG__MAIN___
      INCLUDE 'mpif.h'
      EXTERNAL ORG___MAIN___
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTEGER(KIND=4):: ORG_GRP
      INTEGER(KIND=4), POINTER:: ORG_W2A(:)
      INTEGER(KIND=4):: ORG_ACT_COMM
      INTEGER(KIND=4):: ORG_ACT_RANK
      INTEGER(KIND=4):: ORG_ACT_SIZE
      INTEGER(KIND=4):: ORG_ACT_GRP
      INTEGER(KIND=4), POINTER:: ORG_A2W(:)
      INTEGER(KIND=4):: ierrX0
      INTEGER(KIND=4):: indexX0
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE,ORG_GRP,ORG_W2A
      COMMON /ORG_ACT_COMMON/ORG_ACT_COMM,ORG_ACT_RANK,ORG_ACT_SIZE,ORG_&
     &ACT_GRP,ORG_A2W
      CALL mpi_init(ierrX0)
      CALL mpi_comm_rank(MPI_COMM_WORLD,ORG_RANK,ierrX0)
      CALL mpi_comm_size(MPI_COMM_WORLD,ORG_SIZE,ierrX0)
      CALL mpi_comm_group(MPI_COMM_WORLD,ORG_GRP,ierrX0)
      ORG_ACT_COMM = MPI_COMM_WORLD
      ORG_ACT_RANK = ORG_RANK
      ORG_ACT_SIZE = ORG_SIZE
      ORG_ACT_GRP = ORG_GRP
      ALLOCATE (ORG_A2W(0:ORG_SIZE-1),ORG_W2A(0:ORG_SIZE-1))
      DO indexX0=0,ORG_SIZE-1,1
        ORG_A2W(indexX0) = indexX0
        ORG_W2A(indexX0) = indexX0
      ENDDO
      CALL ORG___MAIN___()
      DEALLOCATE (ORG_W2A,ORG_A2W)
      CALL mpi_finalize(ierrX0)
      END PROGRAM
      SUBROUTINE ORG___MAIN___()
      INCLUDE 'mpif.h'
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      REAL(KIND=4):: ttarget
      PARAMETER (ttarget=60.0e0)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      REAL(KIND=4):: time0(1:2)
      REAL(KIND=4):: time1(1:2)
      EXTERNAL initmt
      INTEGER(KIND=4):: nn
      REAL(KIND=4):: cpu0
      EXTERNAL gdtime
      REAL(KIND=4):: gdtime
      EXTERNAL jacobi
      REAL(KIND=4):: gosa
      REAL(KIND=4):: cpu1
      REAL(KIND=4):: cpu
      REAL(KIND=4):: flop
      INTRINSIC real
      REAL(KIND=4):: xmflops2
      INTRINSIC ifix
      REAL(KIND=4):: score
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      REAL(KIND=4):: wrk2(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: wrk1(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: bnd(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: c(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: b(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: p(0:256,0:128,-1:128/ORG_SIZE+1)
      REAL(KIND=4):: a(0:256,0:128,0:128/ORG_SIZE,0:3)
      INTEGER(KIND=4):: ORG_GRP
      INTEGER(KIND=4), POINTER:: ORG_W2A(:)
      INTEGER(KIND=4):: ORG_ACT_COMM
      INTEGER(KIND=4):: ORG_ACT_RANK
      INTEGER(KIND=4):: ORG_ACT_SIZE
      INTEGER(KIND=4):: ORG_ACT_GRP
      INTEGER(KIND=4), POINTER:: ORG_A2W(:)
      INTEGER(KIND=4):: ierrX0
      COMMON /others/imax,jmax,kmax,omega
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE,ORG_GRP,ORG_W2A
      COMMON /ORG_ACT_COMMON/ORG_ACT_COMM,ORG_ACT_RANK,ORG_ACT_SIZE,ORG_&
     &ACT_GRP,ORG_A2W
      omega = 0.8e0
      imax = 256
      jmax = 128
      kmax = 128
      CALL initmt(p,a,b,c,bnd,wrk1,wrk2)
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' mimax=',257,' mjmax&
     &=',129,' mkmax=',129
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' imax=',imax,' jmax=&
     &',jmax,' kmax=',kmax
      nn = 3
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Start rehearsal mea&
     &surement process.'
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Measure the perform&
     &ance in 3 times.'
      cpu0 = gdtime(time0)
      CALL jacobi(p,a,b,c,bnd,wrk1,wrk2,nn,gosa)
      cpu1 = gdtime(time1)
      cpu = cpu1
      flop = (real(kmax-2))*(real(jmax-2))*(real(imax-2))*(34.0e0)*(real&
     &(nn))
      xmflops2 = flop/cpu*(1.0E-6)
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) '  MFLOPS:',xmflops2,&
     &'  time(s):',cpu,gosa
      nn = ifix(ttarget/(cpu/(3.0e0)))
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'Now, start the actua&
     &l measurement process.'
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'The loop will be exc&
     &uted in',nn,' times.'
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'This will take about&
     & one minute.'
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'Wait for a while.'
      cpu0 = gdtime(time0)
      CALL jacobi(p,a,b,c,bnd,wrk1,wrk2,nn,gosa)
      cpu1 = gdtime(time1)
      cpu = cpu1
      flop = (real(kmax-2))*(real(jmax-2))*(real(imax-2))*(34.0e0)*(real&
     &(nn))
      xmflops2 = flop*(1.0E-6)/cpu
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Loop executed for '&
     &,nn,' times'
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Gosa :',gosa
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' MFLOPS:',xmflops2,'&
     &  time(s):',cpu
      score = xmflops2/(82.84e0)
      IF (ORG_ACT_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Score based on Pent&
     &ium III 600MHz :',score
      RETURN
      END SUBROUTINE
      SUBROUTINE initmt(p,a,b,c,bnd,wrk1,wrk2)
      INCLUDE 'mpif.h'
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      INTEGER(KIND=4):: k
      INTEGER(KIND=4):: j
      INTEGER(KIND=4):: i
      INTRINSIC float
      INTRINSIC max
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      REAL(KIND=4):: wrk2(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: wrk1(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: bnd(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: c(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: b(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: a(0:256,0:128,0:128/ORG_SIZE,0:3)
      REAL(KIND=4):: p(0:256,0:128,-1:128/ORG_SIZE+1)
      INTEGER(KIND=4):: ORG_GRP
      INTEGER(KIND=4), POINTER:: ORG_W2A(:)
      LOGICAL(KIND=4):: maskX0
      LOGICAL(KIND=4):: maskX1
      LOGICAL(KIND=4):: maskX2
      LOGICAL(KIND=4):: maskX3
      INTEGER(KIND=4):: spmdX0
      INTEGER(KIND=4):: spmdX1
      INTEGER(KIND=4):: spmd_startX0
      INTEGER(KIND=4):: spmd_endX0
      INTEGER(KIND=4):: spmd_stepX0
      INTEGER(KIND=4):: spmdX2
      INTEGER(KIND=4):: spmdX3
      INTEGER(KIND=4):: spmd_startX1
      INTEGER(KIND=4):: spmd_endX1
      INTEGER(KIND=4):: spmd_stepX1
      INTEGER(KIND=4):: ORG_ACT_COMM
      INTEGER(KIND=4):: ORG_ACT_RANK
      INTEGER(KIND=4):: ORG_ACT_SIZE
      INTEGER(KIND=4):: ORG_ACT_GRP
      INTEGER(KIND=4), POINTER:: ORG_A2W(:)
      INTEGER(KIND=4):: ierrX0
      INTEGER(KIND=4):: ierrX1
      INTEGER(KIND=4):: rootX0
      INTEGER(KIND=4):: rootX1
      INTEGER(KIND=4):: ierrX2
      INTEGER(KIND=4):: rootX2
      INTEGER(KIND=4):: rootX3
      INTEGER(KIND=4):: ierrX3
      INTEGER(KIND=4):: ierrX4
      INTEGER(KIND=4):: rootX4
      INTEGER(KIND=4):: rootX5
      INTEGER(KIND=4):: ierrX5
      INTEGER(KIND=4):: rootX6
      INTEGER(KIND=4):: rootX7
      INTEGER(KIND=4):: ierrX6
      COMMON /others/imax,jmax,kmax,omega
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE,ORG_GRP,ORG_W2A
      COMMON /ORG_ACT_COMMON/ORG_ACT_COMM,ORG_ACT_RANK,ORG_ACT_SIZE,ORG_&
     &ACT_GRP,ORG_A2W
      spmdX0 = ORG_RANK
      spmdX1 = (128/ORG_SIZE+1)*spmdX0
      IF (spmdX0.LE.0) THEN
        spmd_startX0 = -spmdX1
      ELSE
        spmd_startX0 = 0
      ENDIF
      IF (spmdX0.LT.128/(128/ORG_SIZE+1)) THEN
        spmd_endX0 = 128/ORG_SIZE+0
      ELSE
        spmd_endX0 = 128-spmdX1
      ENDIF
      spmd_stepX0 = 1
      DO k=spmd_startX0,spmd_endX0,1
        DO j=1,129,1
          DO i=1,257,1
            a(i-1,j-1,k,0) = 0.0e0
            a(i-1,j-1,k,1) = 0.0e0
            a(i-1,j-1,k,2) = 0.0e0
            a(i-1,j-1,k,3) = 0.0e0
            b(i-1,j-1,k,0) = 0.0e0
            b(i-1,j-1,k,1) = 0.0e0
            b(i-1,j-1,k,2) = 0.0e0
            c(i-1,j-1,k,0) = 0.0e0
            c(i-1,j-1,k,1) = 0.0e0
            c(i-1,j-1,k,2) = 0.0e0
            p(i-1,j-1,k) = 0.0e0
            wrk1(i-1,j-1,k) = 0.0e0
            bnd(i-1,j-1,k) = 0.0e0
          ENDDO
          maskX1 = .TRUE.
        ENDDO
        maskX0 = .TRUE.
      ENDDO
      k = 130
      IF (maskX0) THEN
        rootX0 = ORG_ACT_RANK
      ELSE
        rootX0 = 0
      ENDIF
      CALL MPI_Allreduce(rootX0,rootX1,1,MPI_INTEGER4,MPI_MAX,ORG_ACT_CO&
     &MM,ierrX2)
      CALL MPI_Bcast(j,1,MPI_INTEGER4,rootX1,ORG_ACT_COMM,ierrX2)
      IF (maskX1) THEN
        rootX2 = ORG_ACT_RANK
      ELSE
        rootX2 = 0
      ENDIF
      CALL MPI_Allreduce(rootX2,rootX3,1,MPI_INTEGER4,MPI_MAX,ORG_ACT_CO&
     &MM,ierrX3)
      CALL MPI_Bcast(i,1,MPI_INTEGER4,rootX3,ORG_ACT_COMM,ierrX3)
      spmdX2 = ORG_RANK
      spmdX3 = (128/ORG_SIZE+1)*spmdX2
      IF (spmdX2.LE.0) THEN
        spmd_startX1 = -spmdX3
      ELSE
        spmd_startX1 = 0
      ENDIF
      IF (spmdX2.LT.(kmax-1)/(128/ORG_SIZE+1)) THEN
        spmd_endX1 = 128/ORG_SIZE+0
      ELSE
        spmd_endX1 = kmax-1-spmdX3
      ENDIF
      spmd_stepX1 = 1
      DO k=spmd_startX1,spmd_endX1,1
        DO j=1,jmax,1
          DO i=1,imax,1
            a(i-1,j-1,k,0) = 1.0e0
            a(i-1,j-1,k,1) = 1.0e0
            a(i-1,j-1,k,2) = 1.0e0
            a(i-1,j-1,k,3) = (1.0e0)/(6.0e0)
            b(i-1,j-1,k,0) = 0.0e0
            b(i-1,j-1,k,1) = 0.0e0
            b(i-1,j-1,k,2) = 0.0e0
            c(i-1,j-1,k,0) = 1.0e0
            c(i-1,j-1,k,1) = 1.0e0
            c(i-1,j-1,k,2) = 1.0e0
            p(i-1,j-1,k) = (float(k*k+2*spmdX3*k+spmdX3*spmdX3))/(float(&
     &kmax*kmax-2*kmax+1))
            wrk1(i-1,j-1,k) = 0.0e0
            bnd(i-1,j-1,k) = 1.0e0
          ENDDO
          maskX3 = .TRUE.
        ENDDO
        maskX2 = .TRUE.
      ENDDO
      k = kmax+1
      IF (maskX2) THEN
        rootX4 = ORG_ACT_RANK
      ELSE
        rootX4 = 0
      ENDIF
      CALL MPI_Allreduce(rootX4,rootX5,1,MPI_INTEGER4,MPI_MAX,ORG_ACT_CO&
     &MM,ierrX5)
      CALL MPI_Bcast(j,1,MPI_INTEGER4,rootX5,ORG_ACT_COMM,ierrX5)
      IF (maskX3) THEN
        rootX6 = ORG_ACT_RANK
      ELSE
        rootX6 = 0
      ENDIF
      CALL MPI_Allreduce(rootX6,rootX7,1,MPI_INTEGER4,MPI_MAX,ORG_ACT_CO&
     &MM,ierrX6)
      CALL MPI_Bcast(i,1,MPI_INTEGER4,rootX7,ORG_ACT_COMM,ierrX6)
      RETURN
      END SUBROUTINE
      SUBROUTINE jacobi(p,a,b,c,bnd,wrk1,wrk2,nn,gosa)
      INCLUDE 'mpif.h'
      INTEGER(KIND=4):: nn
      REAL(KIND=4):: gosa
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      INTEGER(KIND=4):: loop
      INTEGER(KIND=4):: j
      INTEGER(KIND=4):: i
      REAL(KIND=4):: s0
      REAL(KIND=4):: ss
      INTEGER(KIND=4):: k
      INTRINSIC max
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      REAL(KIND=4):: wrk2(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: wrk1(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: bnd(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: c(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: b(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: a(0:256,0:128,0:128/ORG_SIZE,0:3)
      REAL(KIND=4):: p(0:256,0:128,-1:128/ORG_SIZE+1)
      INTEGER(KIND=4):: ORG_GRP
      INTEGER(KIND=4), POINTER:: ORG_W2A(:)
      LOGICAL(KIND=4):: maskX0
      LOGICAL(KIND=4):: maskX1
      INTEGER(KIND=4):: spmdX0
      INTEGER(KIND=4):: spmdX1
      INTEGER(KIND=4):: spmd_startX0
      INTEGER(KIND=4):: spmd_endX0
      INTEGER(KIND=4):: spmd_stepX0
      INTEGER(KIND=4):: spmdX2
      INTEGER(KIND=4):: spmdX3
      INTEGER(KIND=4):: spmd_startX1
      INTEGER(KIND=4):: spmd_endX1
      INTEGER(KIND=4):: spmd_stepX1
      INTEGER(KIND=4):: ORG_ACT_COMM
      INTEGER(KIND=4):: ORG_ACT_RANK
      INTEGER(KIND=4):: ORG_ACT_SIZE
      INTEGER(KIND=4):: ORG_ACT_GRP
      INTEGER(KIND=4), POINTER:: ORG_A2W(:)
      INTEGER(KIND=4):: ierrX0
      INTEGER(KIND=4), ALLOCATABLE:: ireqX0(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX1(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX2(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX3(:)
      INTEGER(KIND=4):: ierrX1
      INTEGER(KIND=4):: statusX0(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: localidX0
      INTEGER(KIND=4):: ierrX2
      REAL(KIND=4):: gosaX0
      REAL(KIND=4):: recvbufX0
      INTEGER(KIND=4):: ierrX3
      INTEGER(KIND=4):: rootX0
      INTEGER(KIND=4):: rootX1
      INTEGER(KIND=4):: ierrX4
      INTEGER(KIND=4):: rootX2
      INTEGER(KIND=4):: rootX3
      INTEGER(KIND=4):: ierrX5
      COMMON /others/imax,jmax,kmax,omega
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE,ORG_GRP,ORG_W2A
      COMMON /ORG_ACT_COMMON/ORG_ACT_COMM,ORG_ACT_RANK,ORG_ACT_SIZE,ORG_&
     &ACT_GRP,ORG_A2W
      DO loop=1,nn,1
        gosa = 0.0e0
        ALLOCATE (ireqX0(0:ORG_SIZE-1),ireqX1(0:ORG_SIZE-1),ireqX2(0:ORG&
     &_SIZE-1),ireqX3(0:ORG_SIZE-1))
        localidX0 = ORG_RANK
        ireqX0 = MPI_REQUEST_NULL
        ireqX1 = MPI_REQUEST_NULL
        ireqX2 = MPI_REQUEST_NULL
        ireqX3 = MPI_REQUEST_NULL
        IF (localidX0.LT.ORG_SIZE-1) THEN
          CALL MPI_Isend(p(0,0,128/ORG_SIZE),33153,MPI_REAL4,ORG_RANK+1,&
     &100,MPI_COMM_WORLD,ireqX0(ORG_RANK+1),ierrX1)
          CALL MPI_Irecv(p(0,0,128/ORG_SIZE+1),33153,MPI_REAL4,ORG_RANK+&
     &1,100,MPI_COMM_WORLD,ireqX3(ORG_RANK+1),ierrX1)
        ENDIF
        IF (localidX0.GT.0) THEN
          CALL MPI_Isend(p(0,0,0),33153,MPI_REAL4,ORG_RANK-1,100,MPI_COM&
     &M_WORLD,ireqX1(ORG_RANK-1),ierrX1)
          CALL MPI_Irecv(p(0,0,-1),33153,MPI_REAL4,ORG_RANK-1,100,MPI_CO&
     &MM_WORLD,ireqX2(ORG_RANK-1),ierrX1)
        ENDIF
        CALL MPI_Waitall(ORG_SIZE,ireqX0,statusX0,ierrX1)
        CALL MPI_Waitall(ORG_SIZE,ireqX1,statusX0,ierrX1)
        CALL MPI_Waitall(ORG_SIZE,ireqX2,statusX0,ierrX1)
        CALL MPI_Waitall(ORG_SIZE,ireqX3,statusX0,ierrX1)
        DEALLOCATE (ireqX0,ireqX1,ireqX2,ireqX3)
        spmdX0 = ORG_RANK
        spmdX1 = (128/ORG_SIZE+1)*spmdX0
        IF (spmdX0.LE.1/(128/ORG_SIZE+1)) THEN
          spmd_startX0 = 1-spmdX1
        ELSE
          spmd_startX0 = 0
        ENDIF
        IF (spmdX0.LT.(kmax-2)/(128/ORG_SIZE+1)) THEN
          spmd_endX0 = 128/ORG_SIZE+0
        ELSE
          spmd_endX0 = kmax-2-spmdX1
        ENDIF
        spmd_stepX0 = 1
        gosaX0 = gosa
        gosa = 0.0e0
        DO k=spmd_startX0,spmd_endX0,1
          DO j=2,jmax-1,1
            DO i=2,imax-1,1
              s0 = a(i-1,j-1,k,0)*p(i,j-1,k)+a(i-1,j-1,k,1)*p(i-1,j,k)+a&
     &(i-1,j-1,k,2)*p(i-1,j-1,k+1)+b(i-1,j-1,k,0)*(p(i,j,k)-p(i,j-2,k)-p&
     &(i-2,j,k)+p(i-2,j-2,k))+b(i-1,j-1,k,1)*(p(i-1,j,k+1)-p(i-1,j-2,k+1&
     &)-p(i-1,j,k-1)+p(i-1,j-2,k-1))+b(i-1,j-1,k,2)*(p(i,j-1,k+1)-p(i-2,&
     &j-1,k+1)-p(i,j-1,k-1)+p(i-2,j-1,k-1))+c(i-1,j-1,k,0)*p(i-2,j-1,k)+&
     &c(i-1,j-1,k,1)*p(i-1,j-2,k)+c(i-1,j-1,k,2)*p(i-1,j-1,k-1)+wrk1(i-1&
     &,j-1,k)
              ss = (s0*a(i-1,j-1,k,3)-p(i-1,j-1,k))*bnd(i-1,j-1,k)
              gosa = gosa+ss*ss
              wrk2(i-1,j-1,k) = p(i-1,j-1,k)+omega*ss
            ENDDO
          ENDDO
        ENDDO
        k = kmax
        CALL MPI_Allreduce(gosa,recvbufX0,1,MPI_REAL4,MPI_SUM,ORG_ACT_CO&
     &MM,ierrX2)
        gosa = gosaX0+recvbufX0
        spmdX2 = ORG_RANK
        spmdX3 = (128/ORG_SIZE+1)*spmdX2
        IF (spmdX2.LE.1/(128/ORG_SIZE+1)) THEN
          spmd_startX1 = 1-spmdX3
        ELSE
          spmd_startX1 = 0
        ENDIF
        IF (spmdX2.LT.(kmax-2)/(128/ORG_SIZE+1)) THEN
          spmd_endX1 = 128/ORG_SIZE+0
        ELSE
          spmd_endX1 = kmax-2-spmdX3
        ENDIF
        spmd_stepX1 = 1
        DO k=spmd_startX1,spmd_endX1,1
          DO j=2,jmax-1,1
            DO i=2,imax-1,1
              p(i-1,j-1,k) = wrk2(i-1,j-1,k)
            ENDDO
            maskX1 = .TRUE.
          ENDDO
          maskX0 = .TRUE.
        ENDDO
        k = kmax
        IF (maskX0) THEN
          rootX0 = ORG_ACT_RANK
        ELSE
          rootX0 = 0
        ENDIF
        CALL MPI_Allreduce(rootX0,rootX1,1,MPI_INTEGER4,MPI_MAX,ORG_ACT_&
     &COMM,ierrX4)
        CALL MPI_Bcast(j,1,MPI_INTEGER4,rootX1,ORG_ACT_COMM,ierrX4)
        IF (maskX1) THEN
          rootX2 = ORG_ACT_RANK
        ELSE
          rootX2 = 0
        ENDIF
        CALL MPI_Allreduce(rootX2,rootX3,1,MPI_INTEGER4,MPI_MAX,ORG_ACT_&
     &COMM,ierrX5)
        CALL MPI_Bcast(i,1,MPI_INTEGER4,rootX3,ORG_ACT_COMM,ierrX5)
      ENDDO
      RETURN
      END SUBROUTINE
      FUNCTION gdtime(time)
      INCLUDE 'mpif.h'
      REAL(KIND=4):: gdtime
      REAL(KIND=4):: time(1:2)
      REAL(KIND=4):: ldtime(0:0)
      EXTERNAL dtime
      REAL(KIND=4):: dtime
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTEGER(KIND=4):: ORG_GRP
      INTEGER(KIND=4), POINTER:: ORG_W2A(:)
      REAL(KIND=4):: UTL_tmp001
      INTEGER(KIND=4):: ORG_ACT_COMM
      INTEGER(KIND=4):: ORG_ACT_RANK
      INTEGER(KIND=4):: ORG_ACT_SIZE
      INTEGER(KIND=4):: ORG_ACT_GRP
      INTEGER(KIND=4), POINTER:: ORG_A2W(:)
      INTEGER(KIND=4):: ierrX0
      INTRINSIC mod
      REAL(KIND=4):: ldtimeX0
      INTEGER(KIND=4):: ierrX1
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE,ORG_GRP,ORG_W2A
      COMMON /ORG_ACT_COMMON/ORG_ACT_COMM,ORG_ACT_RANK,ORG_ACT_SIZE,ORG_&
     &ACT_GRP,ORG_A2W
      UTL_tmp001 = dtime(time)
      IF (0.EQ.ORG_RANK) ldtime(mod(0,1)) = UTL_tmp001
      IF (ORG_RANK.EQ.0) ldtimeX0 = ldtime(mod(0,1))
      indexX0 = ORG_W2A(0)
      CALL MPI_Bcast(ldtimeX0,1,MPI_REAL4,indexX0,ORG_ACT_COMM,ierrX1)
      gdtime = ldtimeX0
      RETURN
      END FUNCTION
